#include "StdAfx.h"
#include "UrlDownloadHelper.h"
#include "MyInetUtils_i.c"

#ifndef SAFE_RELEASE(p)
    #define  SAFE_RELEASE(p) \
    if(p) {p.Release();p=NULL;}
#endif

VARTYPE pVarTypes[3]={VT_I4,VT_BSTR,VT_I4};
_ATL_FUNC_INFO OnStartInfo = {CC_STDCALL, VT_EMPTY, 3,{VT_I4,VT_BSTR,VT_I4}};
_ATL_FUNC_INFO OnDataInfo = {CC_STDCALL, VT_EMPTY, 5,{VT_I4,VT_BSTR,VT_I4,VT_I4,VT_I4}};
_ATL_FUNC_INFO OnFinishInfo = {CC_STDCALL, VT_EMPTY, 3,{VT_I4,VT_BSTR,VT_I4}};


//////////////////////////////////////////////////////////////////////////
//test data




//////////////////////////////////////////////////////////////////////////

CUrlDownloadHelper::CUrlDownloadHelper(void)
{
    m_dwCookie = 0;
}

CUrlDownloadHelper::~CUrlDownloadHelper(void)
{
}

BOOL       CUrlDownloadHelper::InitApis()
{   
    HRESULT hResult = S_FALSE;
    if ( ! m_lpPathUtils ) 
    {
        hResult = CoCreateInstance(CLSID_PathUtils, NULL, CLSCTX_INPROC_SERVER,IID_IPathUtils, (void**)&m_lpPathUtils);
        
        if ( FAILED(hResult) )
        {
            return FALSE;
        }

        hResult   = CoCreateInstance(CLSID_CacheUtils, NULL, CLSCTX_INPROC_SERVER,IID_ICacheUtils, (void**)&m_lpCacheUtils);
        if ( FAILED(hResult ) )
        {
            return FALSE;
        }

        hResult   = CoCreateInstance(CLSID_UrlComponents, NULL, CLSCTX_INPROC_SERVER,IID_IUrlComponents, (void**)&m_lpUrlComponents);
        if ( FAILED(hResult ) )
        {
            return FALSE;
        }

        hResult   = CoCreateInstance(CLSID_AsyncDownloader, NULL, CLSCTX_INPROC_SERVER,IID_IAsyncDownloader, (void**)&m_lpAsyncDownloader);
        if ( FAILED(hResult ) )
        {
            return FALSE;
        }
    }

#if USE_DINTERFACE

    IUnknown* pUnk = (IUnknown*)m_lpAsyncDownloader;
    this->DispEventAdvise(pUnk);
#else
    //CComObject<CEventHandler> *pHandler;
    //CComObject<CEventHandler>::CreateInstance(&pHandler);
    HRESULT rc = AtlAdvise(m_lpAsyncDownloader, this->GetUnknown(),
        IID_IAsyncDownloaderStartEvents, &m_dwCookie);

    if ( FAILED(rc ) )
    {
        return FALSE;
    }

#endif

    long lRetID=0;
    BSTR bsURL(L"https://cisco.webex.com/client/test.7z");
    m_lpAsyncDownloader->RequestDownload(bsURL,TRUE,&lRetID);

    return TRUE;
}
void       CUrlDownloadHelper::UnInitApis()
{
#if USE_DINTERFACE
        IUnknown* pUnk = (IUnknown*)m_lpAsyncDownloader;
        this->DispEventUnadvise(pUnk);
#else
    if (m_lpAsyncDownloader)
        AtlUnadvise(m_lpAsyncDownloader, IID_IAsyncDownloaderStartEvents, m_dwCookie);

    m_dwCookie = 0;
#endif

       SAFE_RELEASE(m_lpPathUtils);
       SAFE_RELEASE(m_lpCacheUtils);
       SAFE_RELEASE(m_lpUrlComponents);
       SAFE_RELEASE(m_lpAsyncDownloader);


}

#if USE_DINTERFACE
#else

STDMETHODIMP CUrlDownloadHelper::Finished( 
                                   /* [in] */ long DownloadID,
                                   /* [in] */ BSTR URL,
                                   /* [in] */ long TotalBytes) 
{
     ::MessageBox(NULL,_T("OnFinish Got"),_T("VTABLE Got"),MB_OK);

     return S_OK;
}

#endif