#pragma once
#include "StdAfx.h"
#include "atlbase.h"
#include "atlcom.h"
#include "MyInetUtils.h"

//#import "MyInetUtils.dll"
// <UINT nID, class T, const IID* pdiid = &IID_NULL, const GUID* plibid = &GUID_NULL, 
// WORD wMajor = 0, WORD wMinor = 0, class tihclass = CComTypeInfoHolder>

extern _ATL_FUNC_INFO OnStartInfo ;
extern _ATL_FUNC_INFO OnDataInfo ;
extern _ATL_FUNC_INFO OnFinishInfo ;

class CUrlDownloadHelper 

#if USE_DINTERFACE
    : public IDispEventImpl<1, CUrlDownloadHelper, &DIID__IAsyncDownloaderEvents,&LIBID_MYINETUTILSLib>
#else
    : public IDispatchImpl<IAsyncDownloaderStartEvents, &IID_IAsyncDownloaderStartEvents, &LIBID_MYINETUTILSLib>,
    public CComObjectRoot 
#endif

{
public:
    CUrlDownloadHelper(void);
    virtual ~CUrlDownloadHelper(void);

#if USE_DINTERFACE
 BEGIN_SINK_MAP(CUrlDownloadHelper)
       //SINK_ENTRY_EX(1, DIID__IAsyncDownloaderEvents,1,OnStart)
       SINK_ENTRY_INFO(1, DIID__IAsyncDownloaderEvents,1,OnStart,&OnStartInfo)
       SINK_ENTRY_INFO(1, DIID__IAsyncDownloaderEvents,2,OnData,&OnDataInfo)
       SINK_ENTRY_INFO(1, DIID__IAsyncDownloaderEvents,3,OnFinish,&OnFinishInfo)
       //SINK_ENTRY_EX(1, 1, &CUrlDownloadHelper::OnStart)
      // SINK_ENTRY(1, DIID__IAsyncDownloaderEvents, OnFinish)
 END_SINK_MAP()
#else
BEGIN_COM_MAP(CUrlDownloadHelper)
   COM_INTERFACE_ENTRY(IDispatch)
    COM_INTERFACE_ENTRY(IAsyncDownloaderStartEvents)
END_COM_MAP()

    // IAsyncDownloaderStartEvents
    STDMETHOD (Finished)( 
    /* [in] */ long DownloadID,
    /* [in] */ BSTR URL,
    /* [in] */ long TotalBytes) ;


#endif

    //_IAsyncDownloaderEvents

    void  __stdcall OnStart(/*[in]*/ long DownloadID,/*[in]*/ BSTR URL,/*[in]*/ long MaxBytes)
    {
        ::MessageBox(NULL,_T("OnStart Got"),_T("OnStart Got"),MB_OK);
    };
   void __stdcall OnData(/*[in]*/ long DownloadID,/*[in]*/ BSTR URL,/*[in] */long NewBytes,/*[in] */long TotalBytes,/*[in]*/ long MaxBytes)
   {
       ::MessageBox(NULL,_T("OnData Got"),_T("OnData Got"),MB_OK);
   };
   void __stdcall OnFinish(/*[in]*/ long DownloadID,/*[in]*/ BSTR URL,/*[in] */long TotalBytes)
   {
       ::MessageBox(NULL,_T("OnFinish Got"),_T("OnFinish Got"),MB_OK);
   };



//     STDMETHOD(AddRef)()
//     {
// 
//     }
// 
//     STDMETHOD(Release)()
//     {
// 
//     }
// 
// 
//     STDMETHOD(Invoke)(DISPID dispidMember, REFIID riid,
//     LCID lcid, WORD wFlags, DISPPARAMS* pdispparams, VARIANT* pvarResult,
//     EXCEPINFO* pexcepinfo, UINT* puArgErr)
//     {
//         return IDispatchImpl<_IAsyncDownloaderEvents, &DIID__IAsyncDownloaderEvents,&LIBID_MYINETUTILSLib>::Invoke(
//              dispidMember, riid, lcid,
//             wFlags, pdispparams, pvarResult, pexcepinfo, puArgErr);
//     }
public:
    BOOL       InitApis();
    void       UnInitApis();
protected:
    
    CComPtr<IPathUtils>  m_lpPathUtils;
    CComPtr<ICacheUtils>   m_lpCacheUtils;
    CComPtr<IUrlComponents>     m_lpUrlComponents;
    CComPtr<IAsyncDownloader> m_lpAsyncDownloader;

    DWORD  m_dwCookie;
};
