// CopyRight Philipos Sakellaropoulos 2001
// Utils.cpp : Implementation of CCacheUtils
#include "stdafx.h"
#include "MyInetUtils.h"
#include "CacheUtils.h"
#include "UrlComponents.h"

#include <stdio.h>
#include <wininet.h>
#include <urlmon.h>
#include <shlwapi.h>
#include <imagehlp.h>

#define MAXSTR 500

/////////////////////////////////////////////////////////////////////////////
// CCacheUtils

STDMETHODIMP CCacheUtils::SaveURLfileFromCacheToLocalfile(BSTR URLfile, BSTR Localfile,VARIANT_BOOL *Success)
{
    USES_CONVERSION;

    LPINTERNET_CACHE_ENTRY_INFO lpCacheEntry;
    DWORD dwEntrySize=0,dwStreamSize=0;
    HANDLE hStream; FILE *fp;
    LPSTR lpszOut;
	*Success = VARIANT_FALSE; BOOL ok;
	TCHAR sLocalFile[_MAX_PATH],sLocalPath[_MAX_PATH];

    ::RetrieveUrlCacheEntryStream(OLE2CT(URLfile),NULL, &dwEntrySize, TRUE, 0);
    lpCacheEntry = LPINTERNET_CACHE_ENTRY_INFO(new char[dwEntrySize]);
    if (!(hStream = RetrieveUrlCacheEntryStream(OLE2CT(URLfile),lpCacheEntry, 
        &dwEntrySize, TRUE, 0)))
    {
        return S_OK;
    }
    else
    {
        dwStreamSize = lpCacheEntry->dwSizeLow;
        lpszOut = new char[dwStreamSize];
        if (!ReadUrlCacheEntryStream(hStream,0,LPVOID(lpszOut),&dwStreamSize,
            0))
        {
            //ErrorOut(hX,GetLastError(),"ReadUrlCacheEntryStream");
		    return S_OK;
        }
        else
        {
			_tcscpy(sLocalFile,OLE2CT(Localfile));


			_tcscpy(sLocalPath,sLocalFile);
			// not needed - ok = ::PathRemoveFileSpec(sLocalPath);	if(!ok) return S_OK;
			ok = ::MakeSureDirectoryPathExists(sLocalPath);
			if(!ok) return S_OK;

			fp = fopen(sLocalFile, "rb");
			if(fp != NULL) // file does not exist
			{
				fclose(fp);
			}
			else
			{
				// open file to write
				fp = fopen(sLocalFile, "wb");
				if(fp == NULL)
				{
					TCHAR buf[300]; sprintf(buf,"Cannot save %s",sLocalFile);
					//::MessageBox(NULL,buf,"Error",MB_OK);
					return S_OK;
				}
				fwrite(lpszOut,1,dwStreamSize,fp);
				fclose(fp);
				//lpszOut[dwStreamSize]='\0';
			}
        }
    }

    delete (lpCacheEntry);
    delete (lpszOut);
    
    if (UnlockUrlCacheEntryStream(hStream,0))
		*Success = VARIANT_TRUE;

	return S_OK;
} 

STDMETHODIMP CCacheUtils::DownloadToFile(BSTR URLfile, BSTR Localfile,VARIANT_BOOL *Success)
{

	//HRESULT URLDownloadToFile( LPUNKNOWN pCaller,LPCSTR szURL,LPCSTR szFileName,
  //DWORD dwReserved,LPBINDSTATUSCALLBACK lpfnCB

	USES_CONVERSION;  HRESULT hr;  TCHAR sLocalFile[MAX_PATH],sCached[MAX_PATH];
	*Success = VARIANT_FALSE;

	_tcscpy(sLocalFile,OLE2CT(Localfile));
	BOOL ok = ::MakeSureDirectoryPathExists(sLocalFile);
	if(!ok) return S_OK;

	// does not use cache
	//hr = ::URLDownloadToFile(NULL,OLE2CT(URLfile),sLocalFile,0,NULL);
	
	hr = URLDownloadToCacheFile(NULL,OLE2CT(URLfile),sCached,
    URLOSTRM_USECACHEDCOPY,0,NULL);
	if(SUCCEEDED(hr))	*Success = VARIANT_TRUE;
	else return S_OK;

	if(_tcslen(sLocalFile) > 0)
	  ::CopyFile(sCached,sLocalFile,FALSE);
	
	return S_OK;
}


STDMETHODIMP CCacheUtils::UrlCombine(BSTR Base, BSTR Relative, BSTR *Combined)
{
  USES_CONVERSION; TCHAR pszCombined[3000]; DWORD dwCombined = 3000;
	
  HRESULT hr = ::InternetCombineUrl(OLE2CT(Base),OLE2CT(Relative),pszCombined,&dwCombined,ICU_DECODE ); 
  *Combined = CComBSTR(pszCombined).Detach(); 
  return S_OK;
}

STDMETHODIMP CCacheUtils::PathCombine(BSTR Dir, BSTR File, BSTR *Dest)
{
    USES_CONVERSION;  TCHAR pszCombined[3000];

	::PathCombine(pszCombined,OLE2CT(Dir),OLE2CT(File));
	*Dest = CComBSTR(pszCombined).Detach(); 
	return S_OK;
}

STDMETHODIMP CCacheUtils::CrackUrl(BSTR URL, VARIANT CUrl,VARIANT_BOOL *Success)
{
	//[out] BSTR *Scheme,[out,retval] BSTR *HostName,[out,retval] long *Port,
	//[out,retval] BSTR *UserName,[out,retval] BSTR *Password,[out,retval] BSTR *UrlPath,[out,retval] BSTR *ExtraInfo

	USES_CONVERSION;
	TCHAR szScheme[MAXSTR],szHostName[MAXSTR],szUserName[MAXSTR],szPassword[MAXSTR],szUrlPath[MAXSTR],szExtraInfo[MAXSTR];
	// returns a URLComponents object
    
	URL_COMPONENTS uc;
	uc.dwStructSize = sizeof(uc);
	uc.lpszScheme = szScheme;
	uc.lpszHostName = szHostName;
	uc.lpszUserName = szUserName;
	uc.lpszPassword = szPassword;
    uc.lpszUrlPath = szUrlPath;
	uc.lpszExtraInfo = szExtraInfo;

	uc.dwExtraInfoLength = uc.dwHostNameLength = uc.dwPasswordLength = uc.dwSchemeLength = 
		uc.dwUrlPathLength = uc.dwUserNameLength = MAXSTR;

	// Query interface in smart ptr
	CComQIPtr<IUrlComponents> pIUrl = CUrl.pdispVal; 
	if(pIUrl == NULL)
		return E_INVALIDARG;

	BOOL ok = ::InternetCrackUrl(OLE2CT(URL),NULL,ICU_DECODE ,&uc);
	if(!ok)
	{
		CComBSTR n(""); 
		pIUrl->put_FullURL(n);
		pIUrl->put_Scheme(n);
		pIUrl->put_HostName(n);
		pIUrl->put_UserName(n);
		pIUrl->put_Password(n);
		pIUrl->put_UrlPath(n);
		pIUrl->put_ExtraInfo(n);
		pIUrl->put_Port(0);
		return S_OK;
		*Success = VARIANT_FALSE;
		return S_OK;
	}

  
	//CComObject<CUrlComponents> *pUrlComp; IUrlComponents *pIUrl;
    //CComObject<CUrlComponents>::CreateInstance(&pUrlComp);
	//pUrlComp->QueryInterface(IID_IUrlComponents,(LPVOID *)&pIUrl); 

	pIUrl->put_FullURL(URL);
	pIUrl->put_Scheme(CComBSTR(uc.lpszScheme));
	pIUrl->put_HostName(CComBSTR(uc.lpszHostName));
	pIUrl->put_UserName(CComBSTR(uc.lpszUserName));
	pIUrl->put_Password(CComBSTR(uc.lpszPassword));
	pIUrl->put_UrlPath(CComBSTR(uc.lpszUrlPath));
	pIUrl->put_ExtraInfo(CComBSTR(uc.lpszExtraInfo));
	pIUrl->put_Port(uc.nPort);

	// it didn't work as out parameter i dont know why
	//CComVariant vOut;	//vOut.vt = VT_DISPATCH;	vOut.pdispVal = pIUrl.Detach(); vOut.Detach(CUrl);
	*Success = VARIANT_TRUE;
	return S_OK;
}

STDMETHODIMP CCacheUtils::MakeSureDirectoryPathExists(BSTR DirPath,VARIANT_BOOL *Success)
{
	USES_CONVERSION;

	BOOL ok = ::MakeSureDirectoryPathExists(OLE2CT(DirPath));
	if(ok) *Success = VARIANT_TRUE;
	else   *Success = VARIANT_FALSE;

	return S_OK;
}

