// Utils.h : Declaration of the CCacheUtils

#ifndef __CACHEUTILS_H_
#define __CACHEUTILS_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CCacheUtils
class ATL_NO_VTABLE CCacheUtils : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CCacheUtils, &CLSID_CacheUtils>,
	public IDispatchImpl<ICacheUtils, &IID_ICacheUtils, &LIBID_MYINETUTILSLib>
{
public:
	CCacheUtils()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CACHEUTILS)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CCacheUtils)
	COM_INTERFACE_ENTRY(ICacheUtils)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// ICacheUtils
public:
	STDMETHOD(DownloadToFile)(/*[in]*/ BSTR URLfile,/*[in]*/ BSTR Localfile,VARIANT_BOOL *Success);
	STDMETHOD(MakeSureDirectoryPathExists)(/*[in]*/ BSTR DirPath,VARIANT_BOOL *Success);
	STDMETHOD(CrackUrl)(/*[in]*/ BSTR URL,/*[in]*/ VARIANT CUrl,VARIANT_BOOL *Success);
	STDMETHOD(PathCombine)(/*[in]*/ BSTR Dir,/*[in]*/ BSTR File,/*[out,retval]*/ BSTR *Dest);
	STDMETHOD(UrlCombine)(/*[in]*/ BSTR Base,/*[in]*/ BSTR Relative,/*[out,retval]*/ BSTR *Combined);
	STDMETHOD(SaveURLfileFromCacheToLocalfile)(/*[in]*/ BSTR URLfile,/*[out,retval]*/ BSTR Localfile,VARIANT_BOOL *Success);
};

#endif //__CACHEUTILS_H_
